// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/HeadingChangeIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING_CHANGE_INDICATION__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING_CHANGE_INDICATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'direction'
#include "etsi_its_cam_ts_msgs/msg/detail/turning_direction__struct.hpp"
// Member 'action_delta_time'
#include "etsi_its_cam_ts_msgs/msg/detail/delta_time_tenth_of_second__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__HeadingChangeIndication __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__HeadingChangeIndication __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HeadingChangeIndication_
{
  using Type = HeadingChangeIndication_<ContainerAllocator>;

  explicit HeadingChangeIndication_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : direction(_init),
    action_delta_time(_init)
  {
    (void)_init;
  }

  explicit HeadingChangeIndication_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : direction(_alloc, _init),
    action_delta_time(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _direction_type =
    etsi_its_cam_ts_msgs::msg::TurningDirection_<ContainerAllocator>;
  _direction_type direction;
  using _action_delta_time_type =
    etsi_its_cam_ts_msgs::msg::DeltaTimeTenthOfSecond_<ContainerAllocator>;
  _action_delta_time_type action_delta_time;

  // setters for named parameter idiom
  Type & set__direction(
    const etsi_its_cam_ts_msgs::msg::TurningDirection_<ContainerAllocator> & _arg)
  {
    this->direction = _arg;
    return *this;
  }
  Type & set__action_delta_time(
    const etsi_its_cam_ts_msgs::msg::DeltaTimeTenthOfSecond_<ContainerAllocator> & _arg)
  {
    this->action_delta_time = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__HeadingChangeIndication
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__HeadingChangeIndication
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HeadingChangeIndication_ & other) const
  {
    if (this->direction != other.direction) {
      return false;
    }
    if (this->action_delta_time != other.action_delta_time) {
      return false;
    }
    return true;
  }
  bool operator!=(const HeadingChangeIndication_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HeadingChangeIndication_

// alias to use template instance with default allocator
using HeadingChangeIndication =
  etsi_its_cam_ts_msgs::msg::HeadingChangeIndication_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING_CHANGE_INDICATION__STRUCT_HPP_
