// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/InterferenceManagementZoneDefinition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_DEFINITION__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_DEFINITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'interference_management_zone_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/latitude__struct.hpp"
// Member 'interference_management_zone_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/longitude__struct.hpp"
// Member 'interference_management_zone_id'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_id__struct.hpp"
// Member 'interference_management_zone_shape'
#include "etsi_its_cam_ts_msgs/msg/detail/shape__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InterferenceManagementZoneDefinition_
{
  using Type = InterferenceManagementZoneDefinition_<ContainerAllocator>;

  explicit InterferenceManagementZoneDefinition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : interference_management_zone_latitude(_init),
    interference_management_zone_longitude(_init),
    interference_management_zone_id(_init),
    interference_management_zone_shape(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->interference_management_zone_id_is_present = false;
      this->interference_management_zone_shape_is_present = false;
    }
  }

  explicit InterferenceManagementZoneDefinition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : interference_management_zone_latitude(_alloc, _init),
    interference_management_zone_longitude(_alloc, _init),
    interference_management_zone_id(_alloc, _init),
    interference_management_zone_shape(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->interference_management_zone_id_is_present = false;
      this->interference_management_zone_shape_is_present = false;
    }
  }

  // field types and members
  using _interference_management_zone_latitude_type =
    etsi_its_cam_ts_msgs::msg::Latitude_<ContainerAllocator>;
  _interference_management_zone_latitude_type interference_management_zone_latitude;
  using _interference_management_zone_longitude_type =
    etsi_its_cam_ts_msgs::msg::Longitude_<ContainerAllocator>;
  _interference_management_zone_longitude_type interference_management_zone_longitude;
  using _interference_management_zone_id_type =
    etsi_its_cam_ts_msgs::msg::ProtectedZoneId_<ContainerAllocator>;
  _interference_management_zone_id_type interference_management_zone_id;
  using _interference_management_zone_id_is_present_type =
    bool;
  _interference_management_zone_id_is_present_type interference_management_zone_id_is_present;
  using _interference_management_zone_shape_type =
    etsi_its_cam_ts_msgs::msg::Shape_<ContainerAllocator>;
  _interference_management_zone_shape_type interference_management_zone_shape;
  using _interference_management_zone_shape_is_present_type =
    bool;
  _interference_management_zone_shape_is_present_type interference_management_zone_shape_is_present;

  // setters for named parameter idiom
  Type & set__interference_management_zone_latitude(
    const etsi_its_cam_ts_msgs::msg::Latitude_<ContainerAllocator> & _arg)
  {
    this->interference_management_zone_latitude = _arg;
    return *this;
  }
  Type & set__interference_management_zone_longitude(
    const etsi_its_cam_ts_msgs::msg::Longitude_<ContainerAllocator> & _arg)
  {
    this->interference_management_zone_longitude = _arg;
    return *this;
  }
  Type & set__interference_management_zone_id(
    const etsi_its_cam_ts_msgs::msg::ProtectedZoneId_<ContainerAllocator> & _arg)
  {
    this->interference_management_zone_id = _arg;
    return *this;
  }
  Type & set__interference_management_zone_id_is_present(
    const bool & _arg)
  {
    this->interference_management_zone_id_is_present = _arg;
    return *this;
  }
  Type & set__interference_management_zone_shape(
    const etsi_its_cam_ts_msgs::msg::Shape_<ContainerAllocator> & _arg)
  {
    this->interference_management_zone_shape = _arg;
    return *this;
  }
  Type & set__interference_management_zone_shape_is_present(
    const bool & _arg)
  {
    this->interference_management_zone_shape_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int64_t INTERFERENCE_MANAGEMENT_ZONE_SHAPE_MIN =
    0;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__InterferenceManagementZoneDefinition
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InterferenceManagementZoneDefinition_ & other) const
  {
    if (this->interference_management_zone_latitude != other.interference_management_zone_latitude) {
      return false;
    }
    if (this->interference_management_zone_longitude != other.interference_management_zone_longitude) {
      return false;
    }
    if (this->interference_management_zone_id != other.interference_management_zone_id) {
      return false;
    }
    if (this->interference_management_zone_id_is_present != other.interference_management_zone_id_is_present) {
      return false;
    }
    if (this->interference_management_zone_shape != other.interference_management_zone_shape) {
      return false;
    }
    if (this->interference_management_zone_shape_is_present != other.interference_management_zone_shape_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const InterferenceManagementZoneDefinition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InterferenceManagementZoneDefinition_

// alias to use template instance with default allocator
using InterferenceManagementZoneDefinition =
  etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int64_t InterferenceManagementZoneDefinition_<ContainerAllocator>::INTERFERENCE_MANAGEMENT_ZONE_SHAPE_MIN;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_DEFINITION__STRUCT_HPP_
