// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/LanePositionOptions.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'simplelane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__struct.hpp"
// Member 'simple_lane_type'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_type__struct.hpp"
// Member 'detailedlane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_and_type__struct.hpp"
// Member 'lane_position_with_lateral_details'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_with_lateral_details__struct.hpp"
// Member 'traffic_island_position'
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_island_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionOptions __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionOptions __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LanePositionOptions_
{
  using Type = LanePositionOptions_<ContainerAllocator>;

  explicit LanePositionOptions_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : simplelane_position(_init),
    simple_lane_type(_init),
    detailedlane_position(_init),
    lane_position_with_lateral_details(_init),
    traffic_island_position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit LanePositionOptions_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : simplelane_position(_alloc, _init),
    simple_lane_type(_alloc, _init),
    detailedlane_position(_alloc, _init),
    lane_position_with_lateral_details(_alloc, _init),
    traffic_island_position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _simplelane_position_type =
    etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator>;
  _simplelane_position_type simplelane_position;
  using _simple_lane_type_type =
    etsi_its_cam_ts_msgs::msg::LaneType_<ContainerAllocator>;
  _simple_lane_type_type simple_lane_type;
  using _detailedlane_position_type =
    etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>;
  _detailedlane_position_type detailedlane_position;
  using _lane_position_with_lateral_details_type =
    etsi_its_cam_ts_msgs::msg::LanePositionWithLateralDetails_<ContainerAllocator>;
  _lane_position_with_lateral_details_type lane_position_with_lateral_details;
  using _traffic_island_position_type =
    etsi_its_cam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>;
  _traffic_island_position_type traffic_island_position;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__simplelane_position(
    const etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->simplelane_position = _arg;
    return *this;
  }
  Type & set__simple_lane_type(
    const etsi_its_cam_ts_msgs::msg::LaneType_<ContainerAllocator> & _arg)
  {
    this->simple_lane_type = _arg;
    return *this;
  }
  Type & set__detailedlane_position(
    const etsi_its_cam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> & _arg)
  {
    this->detailedlane_position = _arg;
    return *this;
  }
  Type & set__lane_position_with_lateral_details(
    const etsi_its_cam_ts_msgs::msg::LanePositionWithLateralDetails_<ContainerAllocator> & _arg)
  {
    this->lane_position_with_lateral_details = _arg;
    return *this;
  }
  Type & set__traffic_island_position(
    const etsi_its_cam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> & _arg)
  {
    this->traffic_island_position = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_SIMPLELANE_POSITION =
    0u;
  static constexpr uint8_t CHOICE_SIMPLE_LANE_TYPE =
    1u;
  static constexpr uint8_t CHOICE_DETAILEDLANE_POSITION =
    2u;
  static constexpr uint8_t CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS =
    3u;
  static constexpr uint8_t CHOICE_TRAFFIC_ISLAND_POSITION =
    4u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionOptions
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__LanePositionOptions
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LanePositionOptions_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->simplelane_position != other.simplelane_position) {
      return false;
    }
    if (this->simple_lane_type != other.simple_lane_type) {
      return false;
    }
    if (this->detailedlane_position != other.detailedlane_position) {
      return false;
    }
    if (this->lane_position_with_lateral_details != other.lane_position_with_lateral_details) {
      return false;
    }
    if (this->traffic_island_position != other.traffic_island_position) {
      return false;
    }
    return true;
  }
  bool operator!=(const LanePositionOptions_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LanePositionOptions_

// alias to use template instance with default allocator
using LanePositionOptions =
  etsi_its_cam_ts_msgs::msg::LanePositionOptions_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionOptions_<ContainerAllocator>::CHOICE_SIMPLELANE_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionOptions_<ContainerAllocator>::CHOICE_SIMPLE_LANE_TYPE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionOptions_<ContainerAllocator>::CHOICE_DETAILEDLANE_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionOptions_<ContainerAllocator>::CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t LanePositionOptions_<ContainerAllocator>::CHOICE_TRAFFIC_ISLAND_POSITION;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__STRUCT_HPP_
