﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/PathPredicted2.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_PREDICTED2__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_PREDICTED2__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'PATH_PREDICTED_MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__PathPredicted2__PATH_PREDICTED_MIN = 0ll
};

// Include directives for member types
// Member 'path_predicted'
#include "etsi_its_cam_ts_msgs/msg/detail/path_predicted__struct.h"
// Member 'usage_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/usage_indication__struct.h"
// Member 'confidence_level'
#include "etsi_its_cam_ts_msgs/msg/detail/confidence_level__struct.h"

/// Struct defined in msg/PathPredicted2 in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__PathPredicted2
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// PathPredicted2::= SEQUENCE{
  ///     pathPredicted     PathPredicted
  ///    ((WITH COMPONENT (WITH COMPONENTS {..., pathDeltaTime ABSENT, symmetricAreaOffset ABSENT})) |
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF represents a predicted path, predicted trajectory or predicted path zone together with usage information and a prediction confidence.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field pathPredicted: the predicted path (pathDeltaTime ABSENT) or trajectory (pathDeltaTime PRESENT) and/or the path zone (symmetricAreaOffset PRESENT).
  /// *
  /// * @field usageIndication: an indication of how the predicted path will be used.
  /// *
  /// * @field confidenceLevel: the confidence that the path/trajectory in pathPredicted will occur as predicted.
  /// *
  /// * @category: GeoReference information
  /// * @revision: created in V2.2.1
  etsi_its_cam_ts_msgs__msg__PathPredicted path_predicted;
  etsi_its_cam_ts_msgs__msg__UsageIndication usage_indication;
  etsi_its_cam_ts_msgs__msg__ConfidenceLevel confidence_level;
} etsi_its_cam_ts_msgs__msg__PathPredicted2;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__PathPredicted2.
typedef struct etsi_its_cam_ts_msgs__msg__PathPredicted2__Sequence
{
  etsi_its_cam_ts_msgs__msg__PathPredicted2 * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__PathPredicted2__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_PREDICTED2__STRUCT_H_
