// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/PathPredicted2.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_PREDICTED2__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_PREDICTED2__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'path_predicted'
#include "etsi_its_cam_ts_msgs/msg/detail/path_predicted__struct.hpp"
// Member 'usage_indication'
#include "etsi_its_cam_ts_msgs/msg/detail/usage_indication__struct.hpp"
// Member 'confidence_level'
#include "etsi_its_cam_ts_msgs/msg/detail/confidence_level__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPredicted2 __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPredicted2 __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathPredicted2_
{
  using Type = PathPredicted2_<ContainerAllocator>;

  explicit PathPredicted2_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path_predicted(_init),
    usage_indication(_init),
    confidence_level(_init)
  {
    (void)_init;
  }

  explicit PathPredicted2_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path_predicted(_alloc, _init),
    usage_indication(_alloc, _init),
    confidence_level(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _path_predicted_type =
    etsi_its_cam_ts_msgs::msg::PathPredicted_<ContainerAllocator>;
  _path_predicted_type path_predicted;
  using _usage_indication_type =
    etsi_its_cam_ts_msgs::msg::UsageIndication_<ContainerAllocator>;
  _usage_indication_type usage_indication;
  using _confidence_level_type =
    etsi_its_cam_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator>;
  _confidence_level_type confidence_level;

  // setters for named parameter idiom
  Type & set__path_predicted(
    const etsi_its_cam_ts_msgs::msg::PathPredicted_<ContainerAllocator> & _arg)
  {
    this->path_predicted = _arg;
    return *this;
  }
  Type & set__usage_indication(
    const etsi_its_cam_ts_msgs::msg::UsageIndication_<ContainerAllocator> & _arg)
  {
    this->usage_indication = _arg;
    return *this;
  }
  Type & set__confidence_level(
    const etsi_its_cam_ts_msgs::msg::ConfidenceLevel_<ContainerAllocator> & _arg)
  {
    this->confidence_level = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int64_t PATH_PREDICTED_MIN =
    0;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPredicted2
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__PathPredicted2
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::PathPredicted2_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathPredicted2_ & other) const
  {
    if (this->path_predicted != other.path_predicted) {
      return false;
    }
    if (this->usage_indication != other.usage_indication) {
      return false;
    }
    if (this->confidence_level != other.confidence_level) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathPredicted2_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathPredicted2_

// alias to use template instance with default allocator
using PathPredicted2 =
  etsi_its_cam_ts_msgs::msg::PathPredicted2_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int64_t PathPredicted2_<ContainerAllocator>::PATH_PREDICTED_MIN;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__PATH_PREDICTED2__STRUCT_HPP_
