// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleLengthV2.idl
// generated code does not contain a copyright notice
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length_v2__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `vehicle_length_value`
#include "etsi_its_cam_ts_msgs/msg/detail/vehicle_length_value__functions.h"
// Member `trailer_presence_information`
#include "etsi_its_cam_ts_msgs/msg/detail/trailer_presence_information__functions.h"

bool
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__init(etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * msg)
{
  if (!msg) {
    return false;
  }
  // vehicle_length_value
  if (!etsi_its_cam_ts_msgs__msg__VehicleLengthValue__init(&msg->vehicle_length_value)) {
    etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(msg);
    return false;
  }
  // trailer_presence_information
  if (!etsi_its_cam_ts_msgs__msg__TrailerPresenceInformation__init(&msg->trailer_presence_information)) {
    etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * msg)
{
  if (!msg) {
    return;
  }
  // vehicle_length_value
  etsi_its_cam_ts_msgs__msg__VehicleLengthValue__fini(&msg->vehicle_length_value);
  // trailer_presence_information
  etsi_its_cam_ts_msgs__msg__TrailerPresenceInformation__fini(&msg->trailer_presence_information);
}

bool
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__are_equal(const etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * lhs, const etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // vehicle_length_value
  if (!etsi_its_cam_ts_msgs__msg__VehicleLengthValue__are_equal(
      &(lhs->vehicle_length_value), &(rhs->vehicle_length_value)))
  {
    return false;
  }
  // trailer_presence_information
  if (!etsi_its_cam_ts_msgs__msg__TrailerPresenceInformation__are_equal(
      &(lhs->trailer_presence_information), &(rhs->trailer_presence_information)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__copy(
  const etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * input,
  etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * output)
{
  if (!input || !output) {
    return false;
  }
  // vehicle_length_value
  if (!etsi_its_cam_ts_msgs__msg__VehicleLengthValue__copy(
      &(input->vehicle_length_value), &(output->vehicle_length_value)))
  {
    return false;
  }
  // trailer_presence_information
  if (!etsi_its_cam_ts_msgs__msg__TrailerPresenceInformation__copy(
      &(input->trailer_presence_information), &(output->trailer_presence_information)))
  {
    return false;
  }
  return true;
}

etsi_its_cam_ts_msgs__msg__VehicleLengthV2 *
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * msg = (etsi_its_cam_ts_msgs__msg__VehicleLengthV2 *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__VehicleLengthV2), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_cam_ts_msgs__msg__VehicleLengthV2));
  bool success = etsi_its_cam_ts_msgs__msg__VehicleLengthV2__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__destroy(etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__init(etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * data = NULL;

  if (size) {
    data = (etsi_its_cam_ts_msgs__msg__VehicleLengthV2 *)allocator.zero_allocate(size, sizeof(etsi_its_cam_ts_msgs__msg__VehicleLengthV2), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_cam_ts_msgs__msg__VehicleLengthV2__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__fini(etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence *
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * array = (etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence *)allocator.allocate(sizeof(etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__destroy(etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__are_equal(const etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * lhs, const etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__VehicleLengthV2__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence__copy(
  const etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * input,
  etsi_its_cam_ts_msgs__msg__VehicleLengthV2__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_cam_ts_msgs__msg__VehicleLengthV2);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_cam_ts_msgs__msg__VehicleLengthV2 * data =
      (etsi_its_cam_ts_msgs__msg__VehicleLengthV2 *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_cam_ts_msgs__msg__VehicleLengthV2__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_cam_ts_msgs__msg__VehicleLengthV2__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_cam_ts_msgs__msg__VehicleLengthV2__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
