﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/VruMovementControl.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VRU_MOVEMENT_CONTROL__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VRU_MOVEMENT_CONTROL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__MAX = 15
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__UNAVAILABLE = 0
};

/// Constant 'BRAKING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__BRAKING = 1
};

/// Constant 'HARD_BRAKING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__HARD_BRAKING = 2
};

/// Constant 'STOP_PEDALING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__STOP_PEDALING = 3
};

/// Constant 'BRAKING_AND_STOP_PEDALING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__BRAKING_AND_STOP_PEDALING = 4
};

/// Constant 'HARD_BRAKING_AND_STOP_PEDALING'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__HARD_BRAKING_AND_STOP_PEDALING = 5
};

/// Constant 'NO_REACTION'.
enum
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl__NO_REACTION = 6
};

/// Struct defined in msg/VruMovementControl in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__VruMovementControl
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// VruMovementControl ::= INTEGER {
  ///     unavailable                (0),
  ///     braking                    (1),
  ///     hardBraking                (2),
  ///     stopPedaling               (3),
  ///     brakingAndStopPedaling     (4),
  ///     hardBrakingAndStopPedaling (5),
  ///     noReaction                 (6)
  /// }(0..15)
  /// ------------------------------------------------------------------------------
  /// *
  /// *  This DE indicates the status of the possible human control over a VRU vehicle.
  /// *
  /// * The value shall be set to:
  /// * - 0 `unavailable`                 - to indicate that the information is unavailable,
  /// * - 1 `braking`                     - to indicate that the VRU is braking,
  /// * - 2 `hardBraking`                 - to indicate that the VRU is braking hard,
  /// * - 3 `stopPedaling`                - to indicate that the VRU stopped pedaling,
  /// * - 4 `brakingAndStopPedaling`      - to indicate that the VRU stopped pedaling an is braking,
  /// * - 5 `hardBrakingAndStopPedaling`  - to indicate that the VRU stopped pedaling an is braking hard,
  /// * - 6 `noReaction`                  - to indicate that the VRU is not changing its behavior.
  /// * - 7 to 15                         - are reserved for future usage.
  /// *
  /// * @category: VRU information
  /// * @revision: Created in V2.1.1, type changed from ENUMERATED to INTEGER in V2.2.1 and range changed from 0..255 to 0..15
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__VruMovementControl;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__VruMovementControl.
typedef struct etsi_its_cam_ts_msgs__msg__VruMovementControl__Sequence
{
  etsi_its_cam_ts_msgs__msg__VruMovementControl * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__VruMovementControl__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VRU_MOVEMENT_CONTROL__STRUCT_H_
