// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/BasicLaneInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_LANE_INFORMATION__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_LANE_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lane_number'
// Member 'connecting_lane'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__struct.hpp"
// Member 'direction'
#include "etsi_its_cam_ts_msgs/msg/detail/direction__struct.hpp"
// Member 'lane_width'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_width__struct.hpp"
// Member 'connecting_road_section'
#include "etsi_its_cam_ts_msgs/msg/detail/road_section_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicLaneInformation __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicLaneInformation __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BasicLaneInformation_
{
  using Type = BasicLaneInformation_<ContainerAllocator>;

  explicit BasicLaneInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_number(_init),
    direction(_init),
    lane_width(_init),
    connecting_lane(_init),
    connecting_road_section(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lane_width_is_present = false;
      this->connecting_lane_is_present = false;
      this->connecting_road_section_is_present = false;
    }
  }

  explicit BasicLaneInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_number(_alloc, _init),
    direction(_alloc, _init),
    lane_width(_alloc, _init),
    connecting_lane(_alloc, _init),
    connecting_road_section(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lane_width_is_present = false;
      this->connecting_lane_is_present = false;
      this->connecting_road_section_is_present = false;
    }
  }

  // field types and members
  using _lane_number_type =
    etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator>;
  _lane_number_type lane_number;
  using _direction_type =
    etsi_its_cam_ts_msgs::msg::Direction_<ContainerAllocator>;
  _direction_type direction;
  using _lane_width_type =
    etsi_its_cam_ts_msgs::msg::LaneWidth_<ContainerAllocator>;
  _lane_width_type lane_width;
  using _lane_width_is_present_type =
    bool;
  _lane_width_is_present_type lane_width_is_present;
  using _connecting_lane_type =
    etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator>;
  _connecting_lane_type connecting_lane;
  using _connecting_lane_is_present_type =
    bool;
  _connecting_lane_is_present_type connecting_lane_is_present;
  using _connecting_road_section_type =
    etsi_its_cam_ts_msgs::msg::RoadSectionId_<ContainerAllocator>;
  _connecting_road_section_type connecting_road_section;
  using _connecting_road_section_is_present_type =
    bool;
  _connecting_road_section_is_present_type connecting_road_section_is_present;

  // setters for named parameter idiom
  Type & set__lane_number(
    const etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->lane_number = _arg;
    return *this;
  }
  Type & set__direction(
    const etsi_its_cam_ts_msgs::msg::Direction_<ContainerAllocator> & _arg)
  {
    this->direction = _arg;
    return *this;
  }
  Type & set__lane_width(
    const etsi_its_cam_ts_msgs::msg::LaneWidth_<ContainerAllocator> & _arg)
  {
    this->lane_width = _arg;
    return *this;
  }
  Type & set__lane_width_is_present(
    const bool & _arg)
  {
    this->lane_width_is_present = _arg;
    return *this;
  }
  Type & set__connecting_lane(
    const etsi_its_cam_ts_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->connecting_lane = _arg;
    return *this;
  }
  Type & set__connecting_lane_is_present(
    const bool & _arg)
  {
    this->connecting_lane_is_present = _arg;
    return *this;
  }
  Type & set__connecting_road_section(
    const etsi_its_cam_ts_msgs::msg::RoadSectionId_<ContainerAllocator> & _arg)
  {
    this->connecting_road_section = _arg;
    return *this;
  }
  Type & set__connecting_road_section_is_present(
    const bool & _arg)
  {
    this->connecting_road_section_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicLaneInformation
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__BasicLaneInformation
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BasicLaneInformation_ & other) const
  {
    if (this->lane_number != other.lane_number) {
      return false;
    }
    if (this->direction != other.direction) {
      return false;
    }
    if (this->lane_width != other.lane_width) {
      return false;
    }
    if (this->lane_width_is_present != other.lane_width_is_present) {
      return false;
    }
    if (this->connecting_lane != other.connecting_lane) {
      return false;
    }
    if (this->connecting_lane_is_present != other.connecting_lane_is_present) {
      return false;
    }
    if (this->connecting_road_section != other.connecting_road_section) {
      return false;
    }
    if (this->connecting_road_section_is_present != other.connecting_road_section_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const BasicLaneInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BasicLaneInformation_

// alias to use template instance with default allocator
using BasicLaneInformation =
  etsi_its_cam_ts_msgs::msg::BasicLaneInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__BASIC_LANE_INFORMATION__STRUCT_HPP_
