// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/GeneralizedLanePosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'lane_position_based'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_options__struct.hpp"
// Member 'map_based'
#include "etsi_its_cam_ts_msgs/msg/detail/map_position__struct.hpp"
// Member 'confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/meta_information__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__GeneralizedLanePosition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__GeneralizedLanePosition __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GeneralizedLanePosition_
{
  using Type = GeneralizedLanePosition_<ContainerAllocator>;

  explicit GeneralizedLanePosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_position_based(_init),
    map_based(_init),
    confidence(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_based_is_present = false;
    }
  }

  explicit GeneralizedLanePosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_position_based(_alloc, _init),
    map_based(_alloc, _init),
    confidence(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_based_is_present = false;
    }
  }

  // field types and members
  using _lane_position_based_type =
    etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator>;
  _lane_position_based_type lane_position_based;
  using _map_based_type =
    etsi_its_cam_ts_msgs::msg::MapPosition_<ContainerAllocator>;
  _map_based_type map_based;
  using _map_based_is_present_type =
    bool;
  _map_based_is_present_type map_based_is_present;
  using _confidence_type =
    etsi_its_cam_ts_msgs::msg::MetaInformation_<ContainerAllocator>;
  _confidence_type confidence;

  // setters for named parameter idiom
  Type & set__lane_position_based(
    const etsi_its_cam_ts_msgs::msg::LanePositionOptions_<ContainerAllocator> & _arg)
  {
    this->lane_position_based = _arg;
    return *this;
  }
  Type & set__map_based(
    const etsi_its_cam_ts_msgs::msg::MapPosition_<ContainerAllocator> & _arg)
  {
    this->map_based = _arg;
    return *this;
  }
  Type & set__map_based_is_present(
    const bool & _arg)
  {
    this->map_based_is_present = _arg;
    return *this;
  }
  Type & set__confidence(
    const etsi_its_cam_ts_msgs::msg::MetaInformation_<ContainerAllocator> & _arg)
  {
    this->confidence = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__GeneralizedLanePosition
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__GeneralizedLanePosition
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GeneralizedLanePosition_ & other) const
  {
    if (this->lane_position_based != other.lane_position_based) {
      return false;
    }
    if (this->map_based != other.map_based) {
      return false;
    }
    if (this->map_based_is_present != other.map_based_is_present) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const GeneralizedLanePosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GeneralizedLanePosition_

// alias to use template instance with default allocator
using GeneralizedLanePosition =
  etsi_its_cam_ts_msgs::msg::GeneralizedLanePosition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_HPP_
