﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/Heading.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'heading_value'
#include "etsi_its_cam_ts_msgs/msg/detail/heading_value__struct.h"
// Member 'heading_confidence'
#include "etsi_its_cam_ts_msgs/msg/detail/heading_confidence__struct.h"

/// Struct defined in msg/Heading in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__Heading
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// Heading ::= SEQUENCE {
  ///     headingValue         HeadingValue,
  ///     headingConfidence    HeadingConfidence
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF represents the Heading in a WGS84 co-ordinates system.
  /// * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field headingValue: the heading value.
  /// *
  /// * @field headingConfidence: the confidence value of the heading value with a predefined confidence level.
  /// *
  /// * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84Angle instead.
  /// * @category: Kinematic Information
  /// * @revision: Description revised in V2.1.1
  etsi_its_cam_ts_msgs__msg__HeadingValue heading_value;
  etsi_its_cam_ts_msgs__msg__HeadingConfidence heading_confidence;
} etsi_its_cam_ts_msgs__msg__Heading;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__Heading.
typedef struct etsi_its_cam_ts_msgs__msg__Heading__Sequence
{
  etsi_its_cam_ts_msgs__msg__Heading * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__Heading__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__HEADING__STRUCT_H_
