// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/InterferenceManagementZoneDefinition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_DEFINITION__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_DEFINITION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/interference_management_zone_definition__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'interference_management_zone_latitude'
#include "etsi_its_cam_ts_msgs/msg/detail/latitude__traits.hpp"
// Member 'interference_management_zone_longitude'
#include "etsi_its_cam_ts_msgs/msg/detail/longitude__traits.hpp"
// Member 'interference_management_zone_id'
#include "etsi_its_cam_ts_msgs/msg/detail/protected_zone_id__traits.hpp"
// Member 'interference_management_zone_shape'
#include "etsi_its_cam_ts_msgs/msg/detail/shape__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const InterferenceManagementZoneDefinition & msg,
  std::ostream & out)
{
  out << "{";
  // member: interference_management_zone_latitude
  {
    out << "interference_management_zone_latitude: ";
    to_flow_style_yaml(msg.interference_management_zone_latitude, out);
    out << ", ";
  }

  // member: interference_management_zone_longitude
  {
    out << "interference_management_zone_longitude: ";
    to_flow_style_yaml(msg.interference_management_zone_longitude, out);
    out << ", ";
  }

  // member: interference_management_zone_id
  {
    out << "interference_management_zone_id: ";
    to_flow_style_yaml(msg.interference_management_zone_id, out);
    out << ", ";
  }

  // member: interference_management_zone_id_is_present
  {
    out << "interference_management_zone_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.interference_management_zone_id_is_present, out);
    out << ", ";
  }

  // member: interference_management_zone_shape
  {
    out << "interference_management_zone_shape: ";
    to_flow_style_yaml(msg.interference_management_zone_shape, out);
    out << ", ";
  }

  // member: interference_management_zone_shape_is_present
  {
    out << "interference_management_zone_shape_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.interference_management_zone_shape_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InterferenceManagementZoneDefinition & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: interference_management_zone_latitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_latitude:\n";
    to_block_style_yaml(msg.interference_management_zone_latitude, out, indentation + 2);
  }

  // member: interference_management_zone_longitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_longitude:\n";
    to_block_style_yaml(msg.interference_management_zone_longitude, out, indentation + 2);
  }

  // member: interference_management_zone_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_id:\n";
    to_block_style_yaml(msg.interference_management_zone_id, out, indentation + 2);
  }

  // member: interference_management_zone_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.interference_management_zone_id_is_present, out);
    out << "\n";
  }

  // member: interference_management_zone_shape
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_shape:\n";
    to_block_style_yaml(msg.interference_management_zone_shape, out, indentation + 2);
  }

  // member: interference_management_zone_shape_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "interference_management_zone_shape_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.interference_management_zone_shape_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InterferenceManagementZoneDefinition & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition>()
{
  return "etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition>()
{
  return "etsi_its_cam_ts_msgs/msg/InterferenceManagementZoneDefinition";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::Latitude>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Longitude>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneId>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::Shape>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::Latitude>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Longitude>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::ProtectedZoneId>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::Shape>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::InterferenceManagementZoneDefinition>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_ZONE_DEFINITION__TRAITS_HPP_
