// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/LanePositionOptions.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_options__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'simplelane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position__traits.hpp"
// Member 'simple_lane_type'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_type__traits.hpp"
// Member 'detailedlane_position'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_and_type__traits.hpp"
// Member 'lane_position_with_lateral_details'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_with_lateral_details__traits.hpp"
// Member 'traffic_island_position'
#include "etsi_its_cam_ts_msgs/msg/detail/traffic_island_position__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LanePositionOptions & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: simplelane_position
  {
    out << "simplelane_position: ";
    to_flow_style_yaml(msg.simplelane_position, out);
    out << ", ";
  }

  // member: simple_lane_type
  {
    out << "simple_lane_type: ";
    to_flow_style_yaml(msg.simple_lane_type, out);
    out << ", ";
  }

  // member: detailedlane_position
  {
    out << "detailedlane_position: ";
    to_flow_style_yaml(msg.detailedlane_position, out);
    out << ", ";
  }

  // member: lane_position_with_lateral_details
  {
    out << "lane_position_with_lateral_details: ";
    to_flow_style_yaml(msg.lane_position_with_lateral_details, out);
    out << ", ";
  }

  // member: traffic_island_position
  {
    out << "traffic_island_position: ";
    to_flow_style_yaml(msg.traffic_island_position, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LanePositionOptions & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: simplelane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "simplelane_position:\n";
    to_block_style_yaml(msg.simplelane_position, out, indentation + 2);
  }

  // member: simple_lane_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "simple_lane_type:\n";
    to_block_style_yaml(msg.simple_lane_type, out, indentation + 2);
  }

  // member: detailedlane_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detailedlane_position:\n";
    to_block_style_yaml(msg.detailedlane_position, out, indentation + 2);
  }

  // member: lane_position_with_lateral_details
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_position_with_lateral_details:\n";
    to_block_style_yaml(msg.lane_position_with_lateral_details, out, indentation + 2);
  }

  // member: traffic_island_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "traffic_island_position:\n";
    to_block_style_yaml(msg.traffic_island_position, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LanePositionOptions & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::LanePositionOptions & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::LanePositionOptions & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::LanePositionOptions>()
{
  return "etsi_its_cam_ts_msgs::msg::LanePositionOptions";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::LanePositionOptions>()
{
  return "etsi_its_cam_ts_msgs/msg/LanePositionOptions";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::LanePositionOptions>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::LanePosition>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LanePositionAndType>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LanePositionWithLateralDetails>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::LaneType>::value && has_fixed_size<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::LanePositionOptions>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::LanePosition>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LanePositionAndType>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LanePositionWithLateralDetails>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::LaneType>::value && has_bounded_size<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::LanePositionOptions>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__LANE_POSITION_OPTIONS__TRAITS_HPP_
