// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/StoredInformationType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STORED_INFORMATION_TYPE__STRUCT_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STORED_INFORMATION_TYPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__StoredInformationType __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_cam_ts_msgs__msg__StoredInformationType __declspec(deprecated)
#endif

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct StoredInformationType_
{
  using Type = StoredInformationType_<ContainerAllocator>;

  explicit StoredInformationType_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  explicit StoredInformationType_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  // field types and members
  using _value_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _value_type value;
  using _bits_unused_type =
    uint8_t;
  _bits_unused_type bits_unused;

  // setters for named parameter idiom
  Type & set__value(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__bits_unused(
    const uint8_t & _arg)
  {
    this->bits_unused = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int64_t MIN_SIZE_BITS =
    8;
  static constexpr int64_t MAX_SIZE_BITS =
    8;
  static constexpr uint8_t BIT_INDEX_UNDEFINED =
    0u;
  static constexpr uint8_t BIT_INDEX_STATIC_DB =
    1u;
  static constexpr uint8_t BIT_INDEX_DYNAMIC_DB =
    2u;
  static constexpr uint8_t BIT_INDEX_REAL_TIME_DB =
    3u;
  static constexpr uint8_t BIT_INDEX_MAP =
    4u;

  // pointer types
  using RawPtr =
    etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__StoredInformationType
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_cam_ts_msgs__msg__StoredInformationType
    std::shared_ptr<etsi_its_cam_ts_msgs::msg::StoredInformationType_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StoredInformationType_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    if (this->bits_unused != other.bits_unused) {
      return false;
    }
    return true;
  }
  bool operator!=(const StoredInformationType_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StoredInformationType_

// alias to use template instance with default allocator
using StoredInformationType =
  etsi_its_cam_ts_msgs::msg::StoredInformationType_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int64_t StoredInformationType_<ContainerAllocator>::MIN_SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int64_t StoredInformationType_<ContainerAllocator>::MAX_SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t StoredInformationType_<ContainerAllocator>::BIT_INDEX_UNDEFINED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t StoredInformationType_<ContainerAllocator>::BIT_INDEX_STATIC_DB;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t StoredInformationType_<ContainerAllocator>::BIT_INDEX_DYNAMIC_DB;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t StoredInformationType_<ContainerAllocator>::BIT_INDEX_REAL_TIME_DB;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t StoredInformationType_<ContainerAllocator>::BIT_INDEX_MAP;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__STORED_INFORMATION_TYPE__STRUCT_HPP_
