// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_cam_ts_msgs:msg/TrafficIslandPosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_ISLAND_POSITION__TRAITS_HPP_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_ISLAND_POSITION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_cam_ts_msgs/msg/detail/traffic_island_position__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'one_side'
// Member 'other_side'
#include "etsi_its_cam_ts_msgs/msg/detail/lane_position_and_type__traits.hpp"

namespace etsi_its_cam_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TrafficIslandPosition & msg,
  std::ostream & out)
{
  out << "{";
  // member: one_side
  {
    out << "one_side: ";
    to_flow_style_yaml(msg.one_side, out);
    out << ", ";
  }

  // member: other_side
  {
    out << "other_side: ";
    to_flow_style_yaml(msg.other_side, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TrafficIslandPosition & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: one_side
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "one_side:\n";
    to_block_style_yaml(msg.one_side, out, indentation + 2);
  }

  // member: other_side
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "other_side:\n";
    to_block_style_yaml(msg.other_side, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TrafficIslandPosition & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_cam_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_cam_ts_msgs::msg::TrafficIslandPosition & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_cam_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_cam_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_cam_ts_msgs::msg::TrafficIslandPosition & msg)
{
  return etsi_its_cam_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>()
{
  return "etsi_its_cam_ts_msgs::msg::TrafficIslandPosition";
}

template<>
inline const char * name<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>()
{
  return "etsi_its_cam_ts_msgs/msg/TrafficIslandPosition";
}

template<>
struct has_fixed_size<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>
  : std::integral_constant<bool, has_fixed_size<etsi_its_cam_ts_msgs::msg::LanePositionAndType>::value> {};

template<>
struct has_bounded_size<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>
  : std::integral_constant<bool, has_bounded_size<etsi_its_cam_ts_msgs::msg::LanePositionAndType>::value> {};

template<>
struct is_message<etsi_its_cam_ts_msgs::msg::TrafficIslandPosition>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__TRAFFIC_ISLAND_POSITION__TRAITS_HPP_
